import 'reflect-metadata';

import { injectable } from 'inversify';

import CreateTokenRequest from '../requests/token/create-token.request';
import { maskCardNumber } from '../utils/card.util';
import tokenModel, { Token } from '../models/token.model';
import { TOKEN_EXPIRATION } from '../constants';
import * as mongoUtil from '../database/mongo.database';
import { generateToken } from '../utils/token.util';
import { FilterQuery, ProjectionFields, QueryOptions, UpdateAggregationStage, UpdateWithAggregationPipeline } from 'mongoose';

@injectable()
export default class TokenService {
  public async createOne(tokenDto: CreateTokenRequest) {
    const tokenBuilt = this.buildOne(tokenDto);
    const tokenCreated = await this.saveOne(tokenBuilt);
    return tokenCreated;
  }

  public async saveOne(token: Token) {
    await mongoUtil.connectDatabase();
    const tokenCreated = await tokenModel.create(token);

    return tokenCreated;
  }

  public buildOne(tokenDto: CreateTokenRequest) {
    const cardString = tokenDto.card_number.toString();

    const expiration_date_token = new Date();
    expiration_date_token.setMinutes(expiration_date_token.getMinutes() + TOKEN_EXPIRATION);
    
    const auto_generated_token = generateToken();

    const result: Token = {
      ...tokenDto,
      expired: false,
      auto_generated_token,
      expiration_date_token,
      card_number: maskCardNumber(cardString),
    };

    return result;
  }

  public async findOneByAutoGeneratedToken(auto_generated_token: string) {
    await mongoUtil.connectDatabase();

    const filterQuery: FilterQuery<Token> = { auto_generated_token }
    const projectionFields: ProjectionFields<Token> = { cvv: 0 }
    const queryOptions: QueryOptions = {
      lean: true
    }

    const tokenFound = await tokenModel.findOne<Token>(
      filterQuery,
      projectionFields,
      queryOptions,
    ).lean()

    const result = tokenFound as any as Token
    return result;
  }

  public async setTokenExpired(tokenId: string) {
    await mongoUtil.connectDatabase();

    const filterQuery: FilterQuery<Token> = { _id: tokenId }
    const updateAggregationStage: UpdateAggregationStage = {
      $set: {
        expired: true
      }
    }

    const tokenUpdate = await tokenModel.updateOne(
      filterQuery,
      updateAggregationStage,
    )

    return tokenUpdate
  }
}
